#include "arduino_secrets.h"

#include <EEPROM.h>
#include <SoftwareSerial.h>
bool SerialConn = false;
bool Slave = false;
bool Master = false;
int buad = 9600;
// that variable sets the buad rate; we reccomdend staying at 9600, as it's fast, but not overwhelming for the board :}
int bits = 0;
const byte rxPin = 2;
const byte txPin = 3;
String version = "0010//Alpha2";
String board = "Arduino or Guenio ATMega based UNO R3";
//for reading and writing to the EEPROM - NEVER do this often, as it has limited read/write cycles :/
/*
This is the location where you can include libraries.

Refer to the offical arduino documentation for arduino related help: https://docs.arduino.cc/hardware/uno-rev3/

A link to the LXOSMC documentation will be placed here in a future build.
*/

/* 
LXOSMC uses serial buad rate 9600, as this is very common. 
Remember to set your serial monitor to that :}
*/ 


SoftwareSerial lxSerial (rxPin, txPin);
void setup() {
  Serial.begin(buad);
// Remember, don't want something to be done? Just comment it out, or edit a variable :}
CheckFirstTime();
// Check to see if this is the 1st time the user is booting LXOSMC on this device - so it can begin OOBE! (Comment it out if u just wanna test)
  Serial.println(F("--------------------------LXOSMC boot manager---------------------------"));
    Serial.println(F("You have 2 options to boot into."));
    Serial.println(F("* LXOSMC"));
    Serial.println(F("* function like a normal board"));
    Serial.println(F("To make this board act like normal, just place your code into the normal() function."));
    Serial.println(F("[l == LXOSMC] [f == Funtion like normal]"));
  while(true){
   if(Serial.read() == 'l'){
     kernel();
   }
    if(Serial.read() == 'f'){
      Serial.println(F("Operating normally. Please note that we cannot be responsible for damage to your board due to running forigen code."));
      Serial.println(F("You will need to manually reboot your board using the reset button, \r\n or invoke the setup() function in your code to get back to this boot manager."));
      normal();
    }
  }
    
}

void loop() {
Serial.println(F(""));
Serial.println(F("===================="));
  Serial.println(F("===================="));
  Serial.println(F("    ============"));
  Serial.println(F("      ========"));
  Serial.println(F("        ===="));
  Serial.println(F("        ===="));
  Serial.println(F("        ===="));
  Serial.println(F("      ========"));
  Serial.println(F("    ============"));
  Serial.println(F("===================="));
  Serial.println(F("===================="));
  Serial.print(F("LX OS For Microcontrollers - version "));
  Serial.println(version);
  Serial.println(F("========================LXOSMC Command line========================"));
  Serial.println(F("LXOSMC has finished booting on your board. Currently, you told us"));
  Serial.println(F("that the board LXOSMC is running on is:"));
  Serial.println(board);
  Serial.println(F("type 'h' for a list of commands. Type 'r' to force restart."));
while(true){
    if(Serial.read() == 'r'){
      Serial.println(F("[SYSLOG] Manually invoking setup(), not clearing any variables - RESETING NOW"));
      setup();
    }
}
}

void normal(){
  // place ANY code you want here!
  // code that would go into void setup() would go here...
  while(true){
    // and the code that would go into void loop() would go here!
    
  }
}
// Anything below here is always going to be messing with volitile EEPROM - EDIT AT YOUR OWN RISK.
void kernel(){
  // LXOSMC kernel. EDIT AT YOUR OWN RISK.
  Serial.print(F("[SYSLOG] Current buad rate is set to "));
  Serial.print(buad);
  Serial.println(F("."));
  if(buad > 9600){
    Serial.println(F("This is a fast buad rate and should only be used if needed, as it will make the board work harder."));
  }
  if(buad < 9600){
    Serial.println(F("This is a slow buad rate and should only be used if needed, as it will make the board less responsive."));
  }
  Serial.println(F("You can change that in the 'buad' variable, located at the top of the code."));
  Serial.println(F("[SYSLOG] Reading EEPROM and checking desired pin status."));
  if(EEPROM.read(11) != 1){
    pinMode(13, INPUT);
  }
  if(EEPROM.read(11) == 1){
    pinMode(13, OUTPUT);
  }
  if(EEPROM.read(12) != 1){
    pinMode(12, INPUT);
  }
  if(EEPROM.read(12) == 1){
    pinMode(12, OUTPUT);
  }
  if(EEPROM.read(13) != 1){
    pinMode(11, INPUT);
  }
  if(EEPROM.read(13) == 1){
    pinMode(11, OUTPUT);
  }
  if(EEPROM.read(14) != 1){
    pinMode(10, INPUT);
  }
  if(EEPROM.read(14) == 1){
    pinMode(10, OUTPUT);
  }
  if(EEPROM.read(15) != 1){
    pinMode(9, INPUT);
  }
  if(EEPROM.read(15) == 1){
    pinMode(9, OUTPUT);
  }
  if(EEPROM.read(16) != 1){
    pinMode(8, INPUT);
  }
  if(EEPROM.read(16) == 1){
    pinMode(8, OUTPUT);
  }
  if(EEPROM.read(17) != 1){
    pinMode(7, INPUT);
  }
  if(EEPROM.read(17) == 1){
    pinMode(7, OUTPUT);
  }
  if(EEPROM.read(18) != 1){
    pinMode(6, INPUT);
  }
  if(EEPROM.read(18) == 1){
    pinMode(6, OUTPUT);
  }
  if(EEPROM.read(19) != 1){
    pinMode(5, INPUT);
  }
  if(EEPROM.read(19) == 1){
    pinMode(5, OUTPUT);
  }
  if(EEPROM.read(20) != 1){
    pinMode(4, INPUT);
  }
  if(EEPROM.read(20) == 1){
    pinMode(4, OUTPUT);
  }
 
   Serial.print(F("[SYSLOG] Chcking EEPROM for permenant pps or mmsn..."));
  if(EEPROM.read(150) == 1){
    Serial.println(F("permenant pps found. Connecting now..."));
    lxSerial.print('a');
    delay(1000);
    if(lxSerial.read() == 'a'){
      Serial.println(F("Connection Established!"));
      SerialConn = true;
    }
    else { 
      Serial.println(F("Connection failed to establish. We will try again the next time you initilize communication."));
      Serial.print(F("Currently, pin "));
      Serial.print(rxPin);
      Serial.print(F("is Rx, and pin "));
      Serial.print(txPin);
      Serial.println(F("is Tx. Ensure that they are connected to the Rx and Tx of the 2nd board."));
      SerialConn = false;
    }
  }
  if(EEPROM.read(151) == 1){
    Serial.println(F("permenant mmsn found. This device is a slave."));
    Slave = true;
  }
  if(EEPROM.read(151) == 2){
    Serial.println(F("permenant mmsn found. This device is a master."));
    Master = true;
  } else {
    
    Serial.println(F("No form of communication found."));
    Slave = false;
    Master = false;
    SerialConn = false;
    
  }
    loop();
}
void CheckFirstTime(){
  // here lies the code for checking EEPROM...
  if(EEPROM.read(10) != 200){
    Serial.println(F("====================Agreement===================="));
    Serial.println(F("By using this software, you agree to the GNU public"));
    Serial.println(F("licence agreement. For coding-specific reasons,"));
    Serial.println(F("You also agree to allow this LX Corp Software to"));
    Serial.println(F("preform READ/WRITE cycles to the EEPROM present in"));
    Serial.println(F("your Arduino board. This could possibly harm your"));
    Serial.println(F("board, as EEPROM memory is very volitile."));
    Serial.println(F("Learn more at: https://docs.arduino.cc/learn/programming/eeprom-guide/"));
    Serial.println(F("[y == I Agree][n == I do Not Agree]"));
    
    while(true){
      if(Serial.read() == 'y'){
        // Code to ELECTRICLY ERASE all EEPROM data. This is dangerous and should only be ran when needed.
        Serial.println(F("==============Destructive Action============="));
        Serial.println(F("to begin setting up LXOSMC, we first need to "));
        Serial.println(F("erase any and all data stored in the EEPROM."));
        Serial.println(F("WARNING: if you select 'Erase'[e] ALL DATA"));
        Serial.println(F("IN THE EEPROM WILL BE ELECTRICLY ERASED AND THUS"));
        Serial.println(F("INRECOVERABLE. Select 'quit'[x] to exit this"));
        Serial.println(F("program - the EEPROM will remain untouched. "));
        Serial.println(F("[e == ERASE ALL EEPROM DATA] [x == quit]"));
        while(true){
          
        
        if(Serial.read() == 'e'){
          Serial.print(F("Erasing EEPROM..."));
          for (int i = 0 ; i < EEPROM.length() ; i++) {
            EEPROM.write(i, 0);
          }
          Serial.println(F("Done. Starting OOBE in 3 seconds..."));
          delay(3000);
          oobe();
        }
        if(Serial.read() == 'x'){
        Serial.println(F("You have dissagreed. The board will now become unresponsive and eeprom untouched."));
        delay(500);
        Serial.println(F("[SYSLOG] Running while(true); BOARD WILL BECOME UNRESPONSIVE NOW."));
        
        while(true);
      }
        }
      }
        
      if(Serial.read() == 'n'){
        Serial.println(F("You have dissagreed. The board will now become unresponsive and eeprom untouched."));
        delay(500);
        Serial.println(F("[SYSLOG] Running while(true); BOARD WILL BECOME UNRESPONSIVE NOW."));
        
        while(true);
      }
    }
  }
}
void oobe(){
  Serial.println(F("===================="));
  Serial.println(F("===================="));
  Serial.println(F("    ============"));
  Serial.println(F("      ========"));
  Serial.println(F("        ===="));
  Serial.println(F("        ===="));
  Serial.println(F("        ===="));
  Serial.println(F("      ========"));
  Serial.println(F("    ============"));
  Serial.println(F("===================="));
  Serial.println(F("===================="));
  Serial.print(F("LX OS For Microcontrollers - version "));
  Serial.println(version);
  Serial.println(F("================Welcome to LXOSMC!================"));
  Serial.println(F("Welcome to LX OS for MicroControllers - the ultra"));
  Serial.println(F("-lightweight, comprehensive and useful OS - made "));
  Serial.println(F("just for your microcontroller."));
  Serial.println(F("This OS has features such as:"));
  Serial.println(F(""));
  Serial.println(F("* guides on how to code and debug"));
  Serial.println(F(""));
  Serial.println(F("* comand-line controll over inputs and outputs of the board"));
  Serial.println(F(""));
  Serial.println(F("* EEPROM storage management"));
  Serial.println(F(""));
  Serial.println(F("* Communication between 2 or more devices running LXOSMC"));
  Serial.println(F(""));
  Serial.println(F("* And much, much more!"));
  Serial.println(F("Ready to learn how to use it?"));
  Serial.println(F("[y == next] [n == skip]"));
  while(true){
    if(Serial.read() == 'y'){
      Serial.println(F("===================How to use LXOSMC===================="));
      Serial.println(F("* to preform basic pin control functionalites, simply."));
      Serial.println(F("type the pin number you want to control, and then add"));
      Serial.println(F("a '!' when you want it to be on, and don't include it"));
      Serial.println(F("when you want to turn the pin off."));
      Serial.println(F("* for networking features, the board MUST have SofwareSerial,"));
      Serial.println(F("I2C pins (or some kind of wifi, i'll add that in later biulds)"));
      Serial.println(F("and the other board must be running LXOSMC, AND is the same"));
      Serial.println(F("voltage rating as the other board. Right now, this is a 5V"));
      Serial.println(F("board; so ONLY connect it to other 5V boards (until wifi arrives)"));
      Serial.println(F("You can create 2 kinds of networks on this board, either a"));
      Serial.println(F("Peer - to peer network (ppn) - which means that both devices can"));
      Serial.println(F("transmit and recieve data at high speeds. Then you have"));
      Serial.println(F("Multi - master/slave network (mmsn), which allows many  devices"));
      Serial.println(F("(slaves) to recive data from one device (master), but at"));
      Serial.println(F("lower speeds, and with a lack of being able to talk 2 ways."));
      Serial.println(F("After this Setup finishes, you can type the command 'pps'"));
      Serial.println(F("to begin a peer - to peer network. It will let you know"));
      Serial.println(F("when a proper connection has been established. You can"));
      Serial.println(F("also run 'mmsn' to then make this device a master or slave"));
      Serial.println(F("on a Multi-master/slave network - there will be no confirmation"));
      Serial.println(F("of connection, as slaves can only recive, and masters can only"));
      Serial.println(F("transmit. "));
      Serial.println(F("* Finally, you have an EEPROM storage manager, where you can"));
      Serial.println(F("manage EEPROM storage for the current board, and another one"));
      Serial.println(F("connected trough ppn (or wifi) - you can use 'w' to write"));
      Serial.println(F("something to an EEPROM address, 'c' to change an EEPROM address,"));
      Serial.println(F("and 'd' to delete an EEPROM address. Type 'help' for help!"));
      Serial.println(F("-------------------------------------------------------------."));
      Serial.println(F("So much for an introduction. Are you ready to go?"));
      Serial.println(F("[y == finish setup and boot LXOSMC] "));
      Serial.println(F("This will write <1> bit to EEPROM."));
      while(true){
        if(Serial.read() == 'y'){
          bits = 1;
          Serial.print(F("[SYSLOG] Writing "));
          Serial.print(bits);
          Serial.print(F("to EEPROM..."));
          EEPROM.write(10, 200);
          Serial.println(F("write cycle finished."));
          Serial.println(F("Waiting 3 seconds and booting into the LX OS MC boot manager..."));
          delay(3000);
          setup();
        }
      }
      
    }
    if(Serial.read() == 'n'){
      Serial.println(F("==========Stop=========="));
      Serial.println(F("user selected to end Setup"));
      Serial.println(F("prematurly. Do you want to"));
      Serial.println(F("mark setup as completed?"));
      Serial.println(F("(This will write <1> bit to EEPROM."));
      Serial.println(F("[y == write bit to EEPROM and boot LXOSMC] [n == quit]"));
      bits = 1;
      while(true){
        if(Serial.read() == 'y'){
          Serial.print(F("[SYSLOG] Writing "));
          Serial.print(bits);
          Serial.print(F("to EEPROM..."));
          EEPROM.write(10, 200);
          Serial.println(F("write cycle finished."));
          Serial.println(F("Waiting 3 seconds and booting into the LX OS MC boot manager..."));
          delay(3000);
          setup();
        }
        if(Serial.read() == 'n'){
          Serial.println(F("Ok, the board will become unresponsive now."));
          Serial.println(F("[SYSLOG] Running while(true); BOARD WILL BECOME UNRESPONSIVE NOW."));
          while(true);
          
        }

  
      }
      
    }
  }
  
}